var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
define(["require", "exports", "@syncfusion/ej2-vue-base", "@syncfusion/ej2-maps", "./markersettings.directive", "./colormapping.directive", "./bubblesettings.directive", "./navigationlinesettings.directive", "./layers.directive", "./annotations.directive"], function (require, exports, ej2_vue_base_1, ej2_maps_1, markersettings_directive_1, colormapping_directive_1, bubblesettings_directive_1, navigationlinesettings_directive_1, layers_directive_1, annotations_directive_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.properties = ['annotations', 'background', 'baseLayerIndex', 'border', 'centerPosition', 'description', 'enablePersistence', 'enableRtl', 'format', 'height', 'layers', 'legendSettings', 'locale', 'mapsArea', 'margin', 'projectionType', 'tabIndex', 'theme', 'titleSettings', 'useGroupingSeparator', 'width', 'zoomSettings', 'animationComplete', 'annotationRendering', 'beforePrint', 'bubbleClick', 'bubbleMouseMove', 'bubbleRendering', 'click', 'dataLabelRendering', 'doubleClick', 'itemHighlight', 'itemSelection', 'layerRendering', 'load', 'loaded', 'markerClick', 'markerMouseMove', 'markerRendering', 'resize', 'rightClick', 'shapeHighlight', 'shapeRendering', 'shapeSelected', 'tooltipRender'];
    exports.modelProps = [];
    var MapsComponent = (function (_super) {
        __extends(MapsComponent, _super);
        function MapsComponent() {
            var _this = _super.call(this) || this;
            _this.propKeys = exports.properties;
            _this.models = exports.modelProps;
            _this.hasChildDirective = true;
            _this.hasInjectedModules = true;
            _this.tagMapper = { "e-layers": { "e-layer": { "e-markerSettings": "e-markerSetting", "e-bubbleSettings": { "e-bubbleSetting": { "e-colorMappings": "e-colorMapping" } }, "e-navigationLineSettings": "e-navigationLineSetting" } }, "e-maps-annotations": "e-maps-annotation" };
            _this.tagNameMapper = { "e-colorMappings": "e-colorMapping", "e-maps-annotations": "e-annotations" };
            _this.ej2Instances = new ej2_maps_1.Maps({});
            _this.bindProperties();
            return _this;
        }
        MapsComponent.prototype.render = function (createElement) {
            return createElement('div', this.$slots.default);
        };
        MapsComponent.prototype.addLayer = function (layer) {
            return this.ej2Instances.addLayer(layer);
        };
        MapsComponent.prototype.addMarker = function (layerIndex, marker) {
            return this.ej2Instances.addMarker(layerIndex, marker);
        };
        MapsComponent.prototype.export = function (type, fileName, orientation) {
            return this.ej2Instances.export(type, fileName, orientation);
        };
        MapsComponent.prototype.getLocalizedLabel = function (key) {
            return this.ej2Instances.getLocalizedLabel(key);
        };
        MapsComponent.prototype.mapsOnClick = function (e) {
            return this.ej2Instances.mapsOnClick(e);
        };
        MapsComponent.prototype.mapsOnDoubleClick = function (e) {
            return this.ej2Instances.mapsOnDoubleClick(e);
        };
        MapsComponent.prototype.mapsOnResize = function (e) {
            return this.ej2Instances.mapsOnResize(e);
        };
        MapsComponent.prototype.mouseDownOnMap = function (e) {
            return this.ej2Instances.mouseDownOnMap(e);
        };
        MapsComponent.prototype.mouseEndOnMap = function (e) {
            return this.ej2Instances.mouseEndOnMap(e);
        };
        MapsComponent.prototype.mouseMoveOnMap = function (e) {
            return this.ej2Instances.mouseMoveOnMap(e);
        };
        MapsComponent.prototype.onMouseMove = function (e) {
            return this.ej2Instances.onMouseMove(e);
        };
        MapsComponent.prototype.print = function (id) {
            return this.ej2Instances.print(id);
        };
        MapsComponent.prototype.processResponseJsonData = function (processType, data, layer, dataType) {
            return this.ej2Instances.processResponseJsonData(processType, data, layer, dataType);
        };
        MapsComponent.prototype.removeLayer = function (index) {
            return this.ej2Instances.removeLayer(index);
        };
        MapsComponent.prototype.zoomByPosition = function (centerPosition, zoomFactor) {
            return this.ej2Instances.zoomByPosition(centerPosition, zoomFactor);
        };
        MapsComponent = __decorate([
            ej2_vue_base_1.EJComponentDecorator({
                props: exports.properties
            })
        ], MapsComponent);
        return MapsComponent;
    }(ej2_vue_base_1.ComponentBase));
    exports.MapsComponent = MapsComponent;
    exports.MapsPlugin = {
        name: 'ejs-maps',
        install: function (Vue) {
            Vue.component(exports.MapsPlugin.name, MapsComponent);
            Vue.component(layers_directive_1.LayerPlugin.name, layers_directive_1.LayerDirective);
            Vue.component(layers_directive_1.LayersPlugin.name, layers_directive_1.LayersDirective);
            Vue.component(markersettings_directive_1.MarkerPlugin.name, markersettings_directive_1.MarkerDirective);
            Vue.component(markersettings_directive_1.MarkersPlugin.name, markersettings_directive_1.MarkersDirective);
            Vue.component(bubblesettings_directive_1.BubblePlugin.name, bubblesettings_directive_1.BubbleDirective);
            Vue.component(bubblesettings_directive_1.BubblesPlugin.name, bubblesettings_directive_1.BubblesDirective);
            Vue.component(colormapping_directive_1.ColorMappingPlugin.name, colormapping_directive_1.ColorMappingDirective);
            Vue.component(colormapping_directive_1.ColorMappingsPlugin.name, colormapping_directive_1.ColorMappingsDirective);
            Vue.component(navigationlinesettings_directive_1.NavigationLinePlugin.name, navigationlinesettings_directive_1.NavigationLineDirective);
            Vue.component(navigationlinesettings_directive_1.NavigationLinesPlugin.name, navigationlinesettings_directive_1.NavigationLinesDirective);
            Vue.component(annotations_directive_1.AnnotationPlugin.name, annotations_directive_1.AnnotationDirective);
            Vue.component(annotations_directive_1.AnnotationsPlugin.name, annotations_directive_1.AnnotationsDirective);
        }
    };
});
